# AmoebaGeneralizedKirkwoodForce Class Reference

This class implements an implicit solvation force using the generalized Kirkwood/Grycuk model. More...

`#include <AmoebaGeneralizedKirkwoodForce.h>`

Inheritance diagram for AmoebaGeneralizedKirkwoodForce:

List of all members.

## Classes
class | ParticleInfo
| This is an internal class used to record information about a particle.
## Public Member Functions
| AmoebaGeneralizedKirkwoodForce ()
int | getNumParticles () const
| Get the number of particles in the system.
int | addParticle (double charge, double radius, double scalingFactor)
| Add the parameters for a particle.
void | getParticleParameters (int index, double &charge, double &radius, double &scalingFactor) const
| Get the force field parameters for a particle.
void | setParticleParameters (int index, double charge, double radius, double scalingFactor)
| Set the force field parameters for a particle.
double | getSolventDielectric () const
| Get the dielectric constant for the solvent.
void | setSolventDielectric (double dielectric)
| Set the dielectric constant for the solvent.
double | getSoluteDielectric () const
| Get the dielectric constant for the solute.
void | setSoluteDielectric (double dielectric)
| Set the dielectric constant for the solute.
int | getIncludeCavityTerm () const
| Get the flag signaling whether the cavity term should be included.
void | setIncludeCavityTerm (int includeCavityTerm)
| Set the flag signaling whether the cavity term should be included.
double | getProbeRadius () const
| Get the probe radius (nm) used in SASA contribution.
void | setProbeRadius (double probeRadius)
| Set the probe radius (nm) used in SASA contribution.
double | getSurfaceAreaFactor () const
| Get the surface area factor kJ/(nm*nm) used in SASA contribution.
void | setSurfaceAreaFactor (double surfaceAreaFactor)
| Set the surface area factor kJ/(nm*nm) used in SASA contribution.
void | updateParametersInContext (Context &context)
| Update the per-particle parameters in a Context to match those stored in this Force object.
## Protected Member Functions
ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System.

## Detailed Description

This class implements an implicit solvation force using the generalized Kirkwood/Grycuk model.

To use this class, create an AmoebaGeneralizedKirkwoodForce object, then call addParticle() once for each particle in the System to define its parameters. The number of particles for which you define parameters must be equal to the number of particles in the System, or else an exception will be thrown when you try to create a Context. After a particle has been added, you can modify its force field parameters by calling setParticleParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

## Constructor & Destructor Documentation

AmoebaGeneralizedKirkwoodForce | ( |  | ) |

## Member Function Documentation

int addParticle | ( | double | charge,
|  | double | radius,
|  | double | scalingFactor |
| ) |  |  |

Add the parameters for a particle.

This should be called once for each particle in the System. When it is called for the i'th time, it specifies the parameters for the i'th particle.

Parameters:

  | charge | the charge of the particle, measured in units of the proton charge
  | radius | the atomic radius of the particle, measured in nm
  | scalingFactor | the scaling factor for the particle

Returns:
  the index of the particle that was added

ForceImpl* createImpl | ( |  | ) | const`[protected, virtual]`

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

int getIncludeCavityTerm | ( |  | ) | const

Get the flag signaling whether the cavity term should be included.

int getNumParticles | ( |  | ) | const`[inline]`

Get the number of particles in the system.

void getParticleParameters | ( | int | index,
|  | double & | charge,
|  | double & | radius,
|  | double & | scalingFactor |
| ) |  |  | const

Get the force field parameters for a particle.

Parameters:

  | index | the index of the particle for which to get parameters
  | charge | the charge of the particle, measured in units of the proton charge
  | radius | the atomic radius of the particle, measured in nm
  | scalingFactor | the scaling factor for the particle

double getProbeRadius | ( |  | ) | const

Get the probe radius (nm) used in SASA contribution.

double getSoluteDielectric | ( |  | ) | const`[inline]`

Get the dielectric constant for the solute.

double getSolventDielectric | ( |  | ) | const`[inline]`

Get the dielectric constant for the solvent.

double getSurfaceAreaFactor | ( |  | ) | const

Get the surface area factor kJ/(nm*nm) used in SASA contribution.

void setIncludeCavityTerm | ( | int | includeCavityTerm | ) |

Set the flag signaling whether the cavity term should be included.

void setParticleParameters | ( | int | index,
|  | double | charge,
|  | double | radius,
|  | double | scalingFactor |
| ) |  |  |

Set the force field parameters for a particle.

Parameters:

  | index | the index of the particle for which to set parameters
  | charge | the charge of the particle, measured in units of the proton charge
  | radius | the atomic radius of the particle, measured in nm
  | scalingFactor | the scaling factor for the particle

void setProbeRadius | ( | double | probeRadius | ) |

Set the probe radius (nm) used in SASA contribution.

void setSoluteDielectric | ( | double | dielectric | ) | `[inline]`

Set the dielectric constant for the solute.

void setSolventDielectric | ( | double | dielectric | ) | `[inline]`

Set the dielectric constant for the solvent.

void setSurfaceAreaFactor | ( | double | surfaceAreaFactor | ) |

Set the surface area factor kJ/(nm*nm) used in SASA contribution.

void updateParametersInContext | ( | Context & | context | ) |

Update the per-particle parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setParticleParameters() to modify this object's parameters, then call updateParametersInState() to copy them over to the Context.

The only information this method updates is the values of per-particle parameters. All other aspects of the Force (the probe radius, the surface area factor, etc.) are unaffected and can only be changed by reinitializing the Context.

The documentation for this class was generated from the following file:

- AmoebaGeneralizedKirkwoodForce.h